package com.ruoyi.system.service.impl;

import com.ruoyi.common.security.utils.DictUtils;
import java.util.List;
import com.ruoyi.system.api.domain.SysDictData;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.mapper.SysDictDataMapper;
import org.springframework.stereotype.Service;
import com.ruoyi.system.service.ISysDictDataService;

@Service
public class SysDictDataServiceImpl implements ISysDictDataService
{
    @Autowired
    private SysDictDataMapper dictDataMapper;
    
    public List<SysDictData> selectDictDataList(final SysDictData dictData) {
        return this.dictDataMapper.selectDictDataList(dictData);
    }
    
    public String selectDictLabel(final String dictType, final String dictValue) {
        return this.dictDataMapper.selectDictLabel(dictType, dictValue);
    }
    
    public SysDictData selectDictDataById(final Long dictCode) {
        return this.dictDataMapper.selectDictDataById(dictCode);
    }
    
    public void deleteDictDataByIds(final Long[] dictCodes) {
        for (final Long dictCode : dictCodes) {
            final SysDictData data = this.selectDictDataById(dictCode);
            this.dictDataMapper.deleteDictDataById(dictCode);
            final List<SysDictData> dictDatas = this.dictDataMapper.selectDictDataByType(data.getDictType());
            DictUtils.setDictCache(data.getDictType(), (List)dictDatas);
        }
    }
    
    public int insertDictData(final SysDictData data) {
        final int row = this.dictDataMapper.insertDictData(data);
        if (row > 0) {
            final List<SysDictData> dictDatas = this.dictDataMapper.selectDictDataByType(data.getDictType());
            DictUtils.setDictCache(data.getDictType(), (List)dictDatas);
        }
        return row;
    }
    
    public int updateDictData(final SysDictData data) {
        final int row = this.dictDataMapper.updateDictData(data);
        if (row > 0) {
            final List<SysDictData> dictDatas = this.dictDataMapper.selectDictDataByType(data.getDictType());
            DictUtils.setDictCache(data.getDictType(), (List)dictDatas);
        }
        return row;
    }
}
